; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; 	INPUT:	TEMP1...4	1.Faktor												
;			TEMP5...8 	2.Faktor												
; 																				
; 	OUTPUT:	TEMP1...8															
; 																				
FUNKTION_MULTIPLIKATION_32_32:
; HILFSREGISTER sichern			
	push R0
	push R1
	push R2
	push R3
	push R4
	push R5
	push R6
	push R7
	push R8
	push R9
	push R10
	push R11


; Hilfsregister lschen			
	clr R0
	clr R1
	clr R2
	clr R3
	clr R4
	clr R5
	clr R6
	clr R7

	clr R8
	clr R9
	clr R10
	clr R11

MUL_32_32_w:
	LSR temp8			; 2.Faktor 1x rechts 		
	ROR temp7
	ROR temp6
	ROR temp5
	BRCC MUL_32_32_ww	; kein C rollt heraus 		
	add R0, temp1		; 1. FAKOR addieren			
	adc R1, temp2
	adc R2, temp3
	adc R3, temp4
	adc R4, R8
	adc R5, R9
	adc R6, R10
	adc R7, R11

MUL_32_32_ww:	 
	LSL temp1			; 1. FAKOR 1x links			
	ROL temp2
	ROL temp3
	ROL temp4
	ROL R8
	ROL R9
	ROL R10
	ROL R11

	TST temp5			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp6			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp7			; 2.Faktor = NULL ?	
	brne MUL_32_32_w
	TST temp8			; 2.Faktor = NULL ?	
	brne MUL_32_32_w

	mov temp1, R0		; ERGEBNIS KOPIEREN 		
	mov temp2, R1
	mov temp3, R2
	mov temp4, R3
	mov temp5, R4
	mov temp6, R5
	mov temp7, R6
	mov temp8, R7

; Hilfsregister wieder herstellen	
	pop R11
	pop R10
	pop R9
	pop R8
	pop R7
	pop R6
	pop R5
	pop R4
	pop R3
	pop R2
	pop R1
	pop R0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
